/* Exercice de colles d'informatique */

/* Titre : Implémentation de la bijection entre arbres binaires et arbres
 * généraux. */


/*****************************************/
/* Définition d'un type d'arbres binaire */
/*****************************************/

/* Un noeud d'un arbre binaire est représenté par une structure contenant
 * l'étiquette (un entier) du noeud, son fils gauche et son fils droit.
 * L'arbre vide est représenté par le pointeur NULL. */
struct arbre_b_s {
    int elem;                   /* l'élément stocké dans le noeud */
    struct arbre_b_s* g;        /* le fils gauche du noeud courant */
    struct arbre_b_s* d;        /* le fils dfroit du noeud courant */
} ;

typedef struct arbre_b_s* arbre_b ; /* les arbres binaires */

/****************************************/
/* Définition d'un type d'arbres n-aire */
/****************************************/

/* Un arbre n-aire est représenté par une structure contenant l'étiquette
 * (un entier) du noeud et une forêt qui est l'ensemble ordonné de ses
 * fils. Une forêt est représentée par une liste d'arbres n-aires. */

struct arbre_n_s;
struct liste_arbres_n_s;

struct arbre_n_s {
    int elem ;                     /* l'élément stocké dans le noeud */
    struct foret_s* fils; /* la liste de ses fils */
};
struct foret_s {
    struct arbre_n_s* arbre;       /* un arbre n-aire */
    struct foret_s* next; /* le reste de la liste */
};

/* une forêt est une liste d'arbres n-aires */
typedef struct foret_s* foret ;

/* Q1. Implémenter des fonctions :
 * - de création d'un noeud d'un arbre binaire (prenant en argument un élément, un fils gauche et un fils droit)
 * - de création d'un noeud d'un arbre n-aire (prenant en argument un élément et une forêt)
 * - de création d'un maillon d'une forêt (prenant un argument un arbre n-aire et une forêt)
 * */

/* Q2. Implémenter des fonctions d'affichage permettant l'affichage des
 * structures */

/* Q3. Implémenter une fonction foret_of_arbre_b permettant la traduction
 * d'un arbre binaire en forêt. */

/* Q4. Implémenter une fonction arbre_b_of_foret permettant la traduction
 * d'une forêt en arbre binaire. */
